package com.main.campustream;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.Toast;

/**
 * @author Bryan Crabtree
 * 
 */
public class Campustream extends Activity {

	public static final String SavedInfo = "SavedInfo";
	public static String username = "";
	public static String password = "";
	public static String hashedPassword = "";
	public static String accessToken = "";
	public static Boolean rememberMe = false;

	public static Boolean notifications = false;

	public static String currentProfileUsername = "";
	public static String profileAvatars[] = new String[1000];
	public static String profileAvatarStatuses[] = new String[1000];
	public static Drawable profileIcons[] = new Drawable[1000];

	public static String questionCategoryTitle = "";
	public static String questionSection = "";
	public static String questionID = "";
	public static String questionTitle = "";
	public static String questionMessage = "";
	public static String questionAsker = "";

	public static String newsCategoryTitle = "";
	public static String newsSection = "";
	public static String newsCategory = "";
	public static String newsID = "";
	public static String newsReply = "";
	public static String newsTitle = "";
	public static String newsMessage = "";
	public static String newsAsker = "";

	public static String statusID = "";

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login);

		for (int x = 0; x < profileAvatarStatuses.length; x++) {
			profileAvatarStatuses[x] = "Empty";
		}

		SharedPreferences settings = getSharedPreferences(SavedInfo, 0);
		rememberMe = settings.getBoolean("rememberMe", false);
		notifications = settings.getBoolean("notifications", true);
		if (rememberMe == true) {
			username = settings.getString("username", "");
			password = settings.getString("password", "");

			final EditText nameField = (EditText) findViewById(R.id.EditTextName);
			final EditText passwordField = (EditText) findViewById(R.id.EditTextPassword);
			final CheckBox rememberCheckbox = (CheckBox) findViewById(R.id.CheckBoxRemember);

			nameField.setText(username);
			passwordField.setText(password);
			rememberCheckbox.setChecked(true);
		}
	}

	/**
	 * Called when the user presses the "Login" button.
	 * 
	 * @param button
	 */
	public void userLogin(View button) {
		InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.hideSoftInputFromWindow(findViewById(R.id.EditTextName).getWindowToken(), 0);

		final EditText nameField = (EditText) findViewById(R.id.EditTextName);
		nameField.setText(nameField.getText().toString().trim().toLowerCase());
		if (nameField.getText().toString().contains("wpi.edu")) {
			nameField.setText(nameField.getText().toString().substring(0, nameField.getText().toString().length() - 8));
		}
		username = nameField.getText().toString();

		final EditText passwordField = (EditText) findViewById(R.id.EditTextPassword);
		password = passwordField.getText().toString();

		final CheckBox rememberCheckbox = (CheckBox) findViewById(R.id.CheckBoxRemember);
		rememberMe = rememberCheckbox.isChecked();

		try {
			hashedPassword = SHA1Conversion.SHA1(password);
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}

		accessToken = authenticate();
		if ((accessToken.length() > 10) && (accessToken.length() < 50)) {
			SharedPreferences settings = getSharedPreferences(SavedInfo, 0);
			SharedPreferences.Editor editor = settings.edit();
			editor.putString("username", username);
			editor.putString("password", password);
			editor.putBoolean("rememberMe", rememberMe);
			editor.commit();

			Intent myIntent = new Intent(this, TabView.class);
			startActivityForResult(myIntent, 0);
			finish();
		} else {
			Toast.makeText(this, "Incorrect username or password.", Toast.LENGTH_LONG).show();
		}
	}

	/**
	 * Authenticates the user.
	 * 
	 * @return
	 */
	public String authenticate() {
		String authenticated = "";
		String url = "http://api.campustream.com/1/user/authorize";
		BufferedReader in = null;
		HttpClient client = new DefaultHttpClient();
		HttpPost post = new HttpPost(url);
		ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("username", username));
		params.add(new BasicNameValuePair("password", hashedPassword));
		try {
			UrlEncodedFormEntity ent = new UrlEncodedFormEntity(params);
			post.setEntity(ent);
			HttpResponse response = client.execute(post);
			in = new BufferedReader(new InputStreamReader(response.getEntity().getContent()));
			StringBuffer sb = new StringBuffer("");
			String line = "";
			String NL = System.getProperty("line.separator");
			while ((line = in.readLine()) != null) {
				sb.append(line + NL);
			}
			in.close();
			sb.deleteCharAt(sb.length() - 1);
			authenticated = sb.toString();
		} catch (Exception e) {
			Toast.makeText(this, e.toString(), Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
		return authenticated;
	}

	/**
	 * Opens an HTTP connection with the specified URL.
	 * 
	 * @param urlString
	 * @return
	 * @throws IOException
	 */
	public static InputStream OpenHttpConnection(String urlString) throws IOException {
		InputStream in = null;
		int response = -1;

		URL url = new URL(urlString);
		URLConnection conn = url.openConnection();

		if (!(conn instanceof HttpURLConnection))
			throw new IOException("Not an HTTP Connection!");

		try {
			HttpURLConnection httpConn = (HttpURLConnection) conn;
			httpConn.setAllowUserInteraction(false);
			httpConn.setInstanceFollowRedirects(true);
			httpConn.setRequestMethod("GET");
			httpConn.connect();

			response = httpConn.getResponseCode();
			if (response == HttpURLConnection.HTTP_OK) {
				in = httpConn.getInputStream();
			}
		} catch (Exception ex) {
			throw new IOException("Error Connecting!");
		}
		return in;
	}

	/**
	 * Downloads an image from the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static Bitmap DownloadImage(String URL) {
		Bitmap bitmap = null;
		InputStream in = null;
		try {
			in = OpenHttpConnection(URL);
			bitmap = BitmapFactory.decodeStream(in);
			in.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		int width = bitmap.getWidth();
		int height = bitmap.getHeight();
		int newWidth = 48;
		int newHeight = 48;

		float scaleWidth = ((float) newWidth) / width;
		float scaleHeight = ((float) newHeight) / height;

		Matrix matrix = new Matrix();
		matrix.postScale(scaleWidth, scaleHeight);

		Bitmap resizedBitmap = Bitmap.createBitmap(bitmap, 0, 0, width, height, matrix, true);
		return resizedBitmap;
	}

	/**
	 * Replaces invalid characters in a string.
	 * 
	 * @param message
	 * @return
	 */
	public static String correctString(String message) {
		message = message.replaceAll("&quot;", "\"");
		message = message.replaceAll("&#039;", "'");
		message = message.replaceAll("&amp;", "&");
		message = message.replaceAll("&gt;", ">");
		message = message.replaceAll("&lt;", "<");
		message = message.replaceAll("<br />", "");
		return message;
	}

	/**
	 * Removes text tags from a string.
	 * 
	 * @param message
	 * @return
	 */
	public static String removeTags(String message) {
		message = message.replaceAll("\\[b\\]", "");
		message = message.replaceAll("\\[/b\\]", "");
		message = message.replaceAll("\\[i\\]", "");
		message = message.replaceAll("\\[/i\\]", "");
		message = message.replaceAll("\\[u\\]", "");
		message = message.replaceAll("\\[/u\\]", "");
		message = message.replaceAll("\\[left\\]", "");
		message = message.replaceAll("\\[/left\\]", "");
		message = message.replaceAll("\\[center\\]", "");
		message = message.replaceAll("\\[/center\\]", "");
		message = message.replaceAll("\\[right\\]", "");
		message = message.replaceAll("\\[/right\\]", "");
		message = message.replaceAll("\\[quote\\]", "");
		message = message.replaceAll("\\[/quote\\]", "");
		message = message.replaceAll("\\[img\\]", "");
		message = message.replaceAll("\\[/img\\]", "");
		message = message.replaceAll("\\[url\\]", "");
		message = message.replaceAll("\\[/url\\]", "");
		return message;
	}
}
