package com.main.campustream;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import android.graphics.drawable.Drawable;

/**
 * @author Bryan Crabtree
 * 
 */
public class GetUserInfo {
	public static String GetUserid(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("id");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the username of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserusername(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("username");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the name of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUsername(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("name");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the bio of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserbio(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("bio");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the website of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserwebsite(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("website");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the major(s) of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUsermajor(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("college_majors");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the minor(s) of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserminor(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("college_minors");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the join date of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserJoinDate(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("join_date");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the follow count of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserfollowscount(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("follows_count");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the followers count of the user at the specified URL.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUserfollowerscount(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("followers_count");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the avatar of the user at the specified URL as a web address.
	 * 
	 * @param URL
	 * @return
	 */
	public static String GetUseravatar(String URL) {
		String returnValue = "";
		InputStream in = null;
		try {
			in = Campustream.OpenHttpConnection(URL);
			Document doc = null;
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db;

			try {
				db = dbf.newDocumentBuilder();
				doc = db.parse(in);
			} catch (ParserConfigurationException e) {
				return null;
			} catch (SAXException e) {
				return null;
			}

			doc.getDocumentElement().normalize();

			// Retrieve the user node
			NodeList userNodes = doc.getElementsByTagName("user");

			for (int i = 0; i < userNodes.getLength(); i++) {
				Node userNode = userNodes.item(i);
				if (userNode.getNodeType() == Node.ELEMENT_NODE) {
					// Convert the node into an element
					Element userElement = (Element) userNode;

					// Get the required element under the user
					NodeList returnNodes = (userElement).getElementsByTagName("avatar");

					// Convert the node into an element
					Element returnElement = (Element) returnNodes.item(0);

					// Get the child nodes of the required element
					NodeList textNodes = ((Node) returnElement).getChildNodes();

					// Retrieve the required information
					returnValue = ((Node) textNodes.item(0)).getNodeValue();
				}
			}
		} catch (IOException e1) {
			return null;
		}
		return returnValue;
	}

	/**
	 * Gets the icon of the avatar at the specified URL.
	 * 
	 * @param url
	 * @return
	 */
	public static Drawable GetAvatarIcon(String url) {
		try {
			InputStream is = (InputStream) new URL(url).getContent();
			Drawable drawable = Drawable.createFromStream(is, "src");
			return drawable;
		} catch (Exception e) {
			return null;
		}
	}
}
