package com.main.campustream;

import java.util.ArrayList;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

/**
 * @author Bryan Crabtree
 * 
 */
public class NewsCommentDialog extends Activity implements OnClickListener {
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.commentdialog);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		Button submitButton = (Button) findViewById(R.id.submitButton);
		submitButton.setOnClickListener(submitListener);

		Button cancelButton = (Button) findViewById(R.id.cancelButton);
		cancelButton.setOnClickListener(cancelListener);
	}

	/**
	 * Click listener for the submit button.
	 */
	private OnClickListener submitListener = new OnClickListener() {
		public void onClick(View v) {
			submitNewComment();
			finish();
		}
	};

	/**
	 * Click listener for the cancel button.
	 */
	private OnClickListener cancelListener = new OnClickListener() {
		public void onClick(View v) {
			finish();
		}
	};

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.view.View.OnClickListener#onClick(android.view.View)
	 */
	public void onClick(View v) {
	}

	/**
	 * Submits a new comment for the current new or event item.
	 */
	public void submitNewComment() {
		final EditText commentField = (EditText) findViewById(R.id.commentField);
		String comment = commentField.getText().toString().trim();
		String url = "http://api.campustream.com/1/news/create_comment";
		HttpClient client = new DefaultHttpClient();
		HttpPost post = new HttpPost(url);
		ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("content", comment));
		params.add(new BasicNameValuePair("news_id", Campustream.newsID));
		if (!Campustream.newsReply.equals("")) {
			params.add(new BasicNameValuePair("reply_to", Campustream.newsReply));
		}
		params.add(new BasicNameValuePair("access_token", Campustream.accessToken));
		try {
			UrlEncodedFormEntity ent = new UrlEncodedFormEntity(params);
			post.setEntity(ent);
			client.execute(post);
		} catch (Exception e) {
			Toast.makeText(this, e.toString(), Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
	}

}