package com.main.campustream;

import java.util.ArrayList;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

/**
 * @author Bryan Crabtree
 * 
 */
public class NewsDialog extends Activity implements OnClickListener {
	String[] news_categories = { "1", "2", "3", "4", "5", "6", "7" };

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.app.Activity#onCreate(android.os.Bundle)
	 */
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.newsdialog);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		Button submitButton = (Button) findViewById(R.id.submitButton);
		submitButton.setOnClickListener(submitListener);

		Button cancelButton = (Button) findViewById(R.id.cancelButton);
		cancelButton.setOnClickListener(cancelListener);

		Spinner spinner = (Spinner) findViewById(R.id.categoryField);
		ArrayAdapter<CharSequence> adapter = ArrayAdapter.createFromResource(this, R.array.news_array, android.R.layout.simple_spinner_item);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spinner.setAdapter(adapter);
	}

	/**
	 * Click listener for the submit button.
	 */
	private OnClickListener submitListener = new OnClickListener() {
		public void onClick(View v) {
			submitNews();
			finish();
		}
	};

	/**
	 * Click listener for the cancel button.
	 */
	private OnClickListener cancelListener = new OnClickListener() {
		public void onClick(View v) {
			finish();
		}
	};

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.view.View.OnClickListener#onClick(android.view.View)
	 */
	public void onClick(View v) {
	}

	/**
	 * Submits a news item.
	 */
	public void submitNews() {
		final EditText titleField = (EditText) findViewById(R.id.titleField);
		final EditText messageField = (EditText) findViewById(R.id.messageField);
		final Spinner categoryField = (Spinner) findViewById(R.id.categoryField);
		String title = titleField.getText().toString().trim();
		String message = messageField.getText().toString().trim();
		String category = news_categories[categoryField.getSelectedItemPosition()];
		String url = "http://api.campustream.com/1/news/create";
		HttpClient client = new DefaultHttpClient();
		HttpPost post = new HttpPost(url);
		ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("title", title));
		params.add(new BasicNameValuePair("content", message));
		params.add(new BasicNameValuePair("category", category));
		params.add(new BasicNameValuePair("type", "text"));
		params.add(new BasicNameValuePair("access_token", Campustream.accessToken));
		try {
			UrlEncodedFormEntity ent = new UrlEncodedFormEntity(params);
			post.setEntity(ent);
			client.execute(post);
		} catch (Exception e) {
			Toast.makeText(this, e.toString(), Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
	}

}