package com.main.campustream;

import android.app.Activity;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;

/**
 * @author Bryan Crabtree
 * 
 */
public class SettingsDialog extends Activity implements OnClickListener {
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.settings);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		Button acceptButton = (Button) findViewById(R.id.acceptButton);
		acceptButton.setOnClickListener(acceptListener);

		Button cancelButton = (Button) findViewById(R.id.cancelButton);
		cancelButton.setOnClickListener(cancelListener);

		CheckBox notificationsCheckbox = (CheckBox) findViewById(R.id.CheckBoxNotifications);
		if (Campustream.notifications == true) {
			notificationsCheckbox.setChecked(true);
		} else {
			notificationsCheckbox.setChecked(false);
		}
	}

	/**
	 * Click listener for the accept button.
	 */
	private OnClickListener acceptListener = new OnClickListener() {
		public void onClick(View v) {
			CheckBox notificationsCheckbox = (CheckBox) findViewById(R.id.CheckBoxNotifications);
			if (notificationsCheckbox.isChecked() == true) {
				Campustream.notifications = true;

				SharedPreferences settings = getSharedPreferences(Campustream.SavedInfo, 0);
				SharedPreferences.Editor editor = settings.edit();
				editor.putBoolean("notifications", true);
				editor.commit();
			} else {
				Campustream.notifications = false;

				SharedPreferences settings = getSharedPreferences(Campustream.SavedInfo, 0);
				SharedPreferences.Editor editor = settings.edit();
				editor.putBoolean("notifications", false);
				editor.commit();
			}
			finish();
		}
	};

	/**
	 * Click listener for the cancel button.
	 */
	private OnClickListener cancelListener = new OnClickListener() {
		public void onClick(View v) {
			finish();
		}
	};

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.view.View.OnClickListener#onClick(android.view.View)
	 */
	public void onClick(View v) {
	}
}