package com.main.campustream;

import java.util.ArrayList;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import android.app.Activity;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.Toast;

/**
 * @author Bryan Crabtree
 * 
 */
public class StatusDialog extends Activity implements OnClickListener {
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.statusdialog);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);

		Button submitButton = (Button) findViewById(R.id.submitButton);
		submitButton.setOnClickListener(submitListener);

		Button cancelButton = (Button) findViewById(R.id.cancelButton);
		cancelButton.setOnClickListener(cancelListener);
	}

	/**
	 * Click listener for the submit button.
	 */
	private OnClickListener submitListener = new OnClickListener() {
		public void onClick(View v) {
			submitNewStatus();
			finish();
		}
	};

	/**
	 * Click listener for the cancel button.
	 */
	private OnClickListener cancelListener = new OnClickListener() {
		public void onClick(View v) {
			finish();
		}
	};

	/*
	 * (non-Javadoc)
	 * 
	 * @see android.view.View.OnClickListener#onClick(android.view.View)
	 */
	public void onClick(View v) {
	}

	/**
	 * Submits a new status update.
	 */
	public void submitNewStatus() {
		final EditText messageField = (EditText) findViewById(R.id.messageField);
		String message = messageField.getText().toString().trim();
		final RadioButton publicButton = (RadioButton) findViewById(R.id.publicRadio);
		String url = "http://api.campustream.com/1/statuses/update";
		HttpClient client = new DefaultHttpClient();
		HttpPost post = new HttpPost(url);
		ArrayList<NameValuePair> params = new ArrayList<NameValuePair>();
		params.add(new BasicNameValuePair("message", message));
		if (publicButton.isChecked() == true) {
			params.add(new BasicNameValuePair("public", "true"));
		} else {
			params.add(new BasicNameValuePair("public", "false"));
		}
		params.add(new BasicNameValuePair("access_token", Campustream.accessToken));
		try {
			UrlEncodedFormEntity ent = new UrlEncodedFormEntity(params);
			post.setEntity(ent);
			client.execute(post);
		} catch (Exception e) {
			Toast.makeText(this, e.toString(), Toast.LENGTH_LONG).show();
			e.printStackTrace();
		}
	}

}