<?
/**
 * Handles all settings for Campustream and processes any updates.
 */
class Settings_Controller extends Controller implements REST {
	public $enable_session = true;
	public $template = 'template/main';
	
	public function index($args) {
		if (!$this->session->get('authenticated')) {
			return Hub::redirect('/login');
		}
		
		$facebook = new Facebook(array(
			'appId' => FACEBOOK_APP_ID,
			'secret' => FACEBOOK_SECRET,
			'cookie' => true
		));
		
		$ct = new View('account/settings/_settings_template');
		$ct->active_tab = $args['page'];
		
		$view = new View("account/settings/{$args['page']}");
		$view->user = sess::getUser();
		$view->facebook = $facebook;
		$ct->content = $view->render();
		
		$this->template->active = 'settings';
		$this->template->enable_fbml = true;
		$this->template->content = $ct->render();
		echo $this->template->render();
	}
	
	public function service_hooks() {
		if (!$this->session->get('authenticated')) {
			return;
		}

		if (!isset($_POST['service']) || !isset($_POST['type']) || !isset($_POST['enable'])) {
			return;
		}

		$user = sess::getUser();

		if (!isset($_POST['form_auth']) || $_POST['form_auth'] != md5('zOmg4tehcoolz!' . $user->username)) {
			return;
		}

		$service = $_POST['service'];
		$type = $_POST['type'];
		$enable = $_POST['enable'];
		
		if ($service != 'facebook' && $service != 'twitter') {
			return;
		}
		if ($type != 'import' && $type != 'export') {
			return;
		}
		
		if ($service == 'twitter') {
			if (!$user->has_twitter()) {
				return;
			}
			
			$user->twitter()->{"{$type}_enabled"} = ($enable == 'true' ? 1 : 0);
			$user->twitter()->save();
			
			echo json_encode(array('success' => 1));
		} elseif ($service == 'facebook') {
			if (!$user->has_facebook()) {
				return;
			}
			
			$user->facebook()->{"{$type}_enabled"} = ($enable == 'true' ? 1 : 0);
			$user->facebook()->save();
			
			echo json_encode(array('success' => 1));
		}
	}
	
	public function email() {
		if (!isset($_POST['form_auth']) || $_POST['form_auth'] != md5("fjLDI*YF:S:F&**TF" . sess::getUser()->username)) {
			return;
		}
		
		$enable = ($_POST['enable'] == "false" ? 0 : 1);
		
		$user = sess::getUser();
		$user->email_enabled = $enable;
		$user->save();
		
		echo json_encode(array("success" => 1));
	}
	
	public function profile_photo($args) {
		sess::require_login();
		
		$user = sess::getUser();
		
		if ($args['action'] == 'update') {
			$photo = $_FILES['photo'];
			$type = exif_imagetype($photo['tmp_name']);

			switch ($type) {
				case 1: $type = 'gif'; break;
				case 2: $type = 'jpg'; break;
				case 3: $type = 'png'; break;
				default: $type = false;
			}
			
			if (!$type) {
				return Hub::redirect('/settings/profile?error=invalid_image');
			}
			
			$fsize = filesize($photo['tmp_name']);
			if (($fsize / 1024) > 3072) { // 3MB max
				return Hub::redirect('/settings/profile?error=image_too_large');
			}
			
			copy($photo['tmp_name'], $user->avatar_path('full', $type));
			chmod($user->avatar_path('full', $type), 0777);
			
			$large = new Gmagick();
			$large->readImage($photo['tmp_name']);
			$large->cropthumbnailimage(250, 250);
			$large->write($user->avatar_path('large', $type));
			@chmod($user->avatar_path('large', $type), 0777);
			
			$medium = new Gmagick();
			$medium->readImage($photo['tmp_name']);
			$medium->cropthumbnailimage(128, 128);
			$medium->write($user->avatar_path('medium', $type));
			@chmod($user->avatar_path('medium', $type), 0777);
			
			$small = new Gmagick();
			$small->readImage($photo['tmp_name']);
			$small->cropthumbnailimage(75, 75);
			$small->write($user->avatar_path('small', $type));
			@chmod($user->avatar_path('small', $type), 0777);
			
			$user->has_avatar = 1;
			$user->avatar_format = $type;
			$user->save();
			
			return Hub::redirect('/settings/profile');
			
		} elseif ($args['action'] == 'remove') {
			@unlink($user->avatar_path('full'));
			@unlink($user->avatar_path('large'));
			@unlink($user->avatar_path('medium'));
			@unlink($user->avatar_path('small'));
			
			$user->has_avatar = 0;
			$user->avatar_format = '';
			$user->save();
			
			return Hub::redirect('/settings/profile');
		}
	}
	
	public function update_profile($args) {
		sess::require_login();
		
		// hackish but it works
		foreach($_POST as $key=>$val) {
			$_POST[$key] = trim($val);
		}
		
		if (mb_strlen($_POST['bio']) > 160) {
			$_POST['bio'] = mb_substr($_POST['bio'], 0, 160);
		}
		
		$user = sess::getUser();
		
		$r = RedisManager::connection();
		$first_letter = strtolower(substr($user->name, 0, 1));
		$r->srem("users:by_first_letter:$first_letter", $user->id);
		
		$user->name = htmlspecialchars($_POST['name'], ENT_QUOTES, 'UTF-8');
		//$user->email = $_POST['email'];
		$user->website = str_replace(array('<', '>'), '', $_POST['website']);
		$user->bio = htmlspecialchars($_POST['bio'], ENT_QUOTES, 'UTF-8');
		$user->class_year = is_numeric($_POST['class_year']) && $_POST['class_year'] > 0 ? $_POST['class_year'] : '';
		$user->college_majors = htmlspecialchars($_POST['college_majors'], ENT_QUOTES, 'UTF-8');
		$user->college_minors = htmlspecialchars($_POST['college_minors'], ENT_QUOTES, 'UTF-8');
		
		$user->save();
		
		$first_letter = strtolower(substr($user->name, 0, 1));
		$r->sadd("users:by_first_letter:$first_letter", $user->id);
		
		Hub::redirect('/settings/profile');
		
	}
}