<?
/**
 * A simple stats system that tracks how many times each controller/method
 * is executed, and which data type is requested (HTML, JSON, etc). Uses
 * Redis for data storage.
 */
class Stats_Controller extends Controller {
	public $template = 'template/main';
	public $enable_session = true;
	
	public function index($args) {
		$r = RedisManager::connection();
		
		// Get stats by method
		$method_len = $r->llen('stats:by_method');
		$method_stats = $r->lrange('stats:by_method', 0, $method_len);

		$stats_by_method = array();
		foreach($method_stats as $method) {
			$method = unserialize($method);
			
			$key = "stats:{$method['controller']}:{$method['method']}:{$method['format']}:page_views";
			$stats_by_method[$method['controller']][$method['method']][$method['format']] = $r->get($key);
		}
		
		ksort($stats_by_method);
		
		// Total page views for site
		$total_views = $r->get('stats:total_views');
		
		$view = new View('admin/stats');
		$view->total_views = $total_views;
		$view->stats_by_method = $stats_by_method;
		
		$this->template->content = $view->render();
		echo $this->template->render();
	}
}