<?

/**
 * Subrouter for the API. This gives Hub its nice REST API endpoints.
 */
class Apiv1_Controller extends Controller {

	// this method acts as a subrouter for the api. it assumes that -all- requests will
	// come in with two args- controller and method. it checks the $api array in routes
	// for valid matches before allowing routing to occur.
	public function dispatch($args) {
		Hub::$activecontroller = null;
		
		require( $GLOBALS['APPROOT'] . 'application/config/routes.php' );
		
		$uri = "{$args['controller']}/{$args['method']}";
		
		// use everything passed into $_GET as a url arg for compatibility.
		$args['args'] = $_GET;

		// check to see if the route exists in the $api array- if it does, re-run
		// the router with that.
		foreach( $api as $regex => $call ) {

			if ( preg_match('#^'.$regex.'$#u', $uri) ) {

				$routed_uri = preg_replace('#^'.$regex.'$#u', $call, $uri);
				$args['path'] = null;
				
				$folders = explode('.', $routed_uri);
				if (count($folders) > 1) {
					$routed_uri = array_pop($folders);
					$args['path'] = join('/', $folders );
				}
				
				list( $args['controller'], $args['method'] ) = explode('/', $routed_uri);
				
				include $GLOBALS['APPROOT'] . "application/controllers/{$args['path']}/{$args['controller']}.php";
				
				$args['controller'] = ucfirst($args['controller']);
				
				$reflector = new ReflectionClass("{$args['controller']}_Controller");
				
				// Make sure Controller implements REST interface
				if ( ! $reflector->implementsInterface('REST') ) {
					break;
				}
				
				$args['key'] = $_REQUEST['key'];

				Router::run($args);
				return;
			}
		}
		
		// let the client know that we acknowledged the request but are refusing to
		// respond to it. 404 would not be appropriate here
		Hub::http_error(501, "API Method not implemented");

	}
}