<?

/**
 * Handles posting of comments on status updates.
 */
class Comment_Controller extends Controller implements REST {
	public $enable_session = true;
	
	/**
	 * Adds a comment to the specified status
	 */
	public function update() {
		if (!$this->session->get('authenticated')) {
			return Hub::http_error(403, "Not authenticated");
		}
		
		$status_id = $_POST['status_id'];
		if (!$status_id || !is_numeric($status_id)) {
			return Hub::http_error(401, "Missing or invalid parent status ID");
		}
		
		$message = trim($_POST['message']);
		if (!$message || !strlen($message)) {
			return Hub::http_error(401, "Missing status message");
		}
				
		$user = sess::getUser();
		
		$comment = new Statuscomment_Model();
		$comment->user_id = $user->id;
		$comment->status_id = $status_id;
		$comment->message = htmlspecialchars($message, ENT_QUOTES, 'UTF-8');
		$comment->post_date = ActiveRecord::NOW();
		
		$comment->save();
		
		View::respond_to(array('json', 'xml'), function($format) use($comment) {
			$comment->load_user();
			echo $comment->{"to_$format"}();
		});
	}
}