<?

/**
 * Used for handling account confirmation after registration.
 */
class Confirm_Controller extends Controller {
	public $enable_session = true;
	
	/**
	 * Displays the waiting page immediately after registration.
	 */
	public function wait() {
		sess::require_login();
		
		$view = new View('confirm/wait');
		$view->user = sess::getUser();
		
		echo $view->render();
	}
	
	/**
	 * If the given code is correct, set the user as confirmed and then
	 * send them to their profile settings page.
	 */
	public function do_action() {
		sess::require_login();
		
		if (!isset($_GET['code'])) {
			return Hub::redirect('/confirm/wait');
		}
		
		$user = sess::getUser();
		
		if ($user->confirm_code === $_GET['code']) {
			$user->confirmed = 1;
			$user->save();
			
			return Hub::redirect('/settings/profile');
		} else {
			return Hub::redirect('/confirm/wait');
		}
	}
}