<?

/**
 * Handles authorization and deauthorization of Facebook
 * accounts.
 */
class Facebook_Controller extends Controller {
	public $enable_session = true;
	
	/**
	 * Authorizes a Facebook account and saves the information
	 * in the userfacebook MySQL table.
	 */
	public function authorize() {
		sess::require_login();
		$active_user = sess::getUser();
		
		$facebook = new Facebook(array(
			'appId' => FACEBOOK_APP_ID,
			'secret' => FACEBOOK_SECRET,
			'cookie' => true
		));
		
		$session = $facebook->getSession();

		$user = null;
		if ($session) {
			try {
				$user = $facebook->api('/me');
			} catch (FacebookApiException $e) {
				Logger::debug("FB Error: {$e->getMessage()}");
			}
		}

		$fbuser = new Userfacebook_Model();
		$fbuser->user_id = $active_user->id;
		$fbuser->fb_id = $user['id'];
		$fbuser->username = $facebook->getUser();
		$fbuser->access_token = $facebook->getAccessToken();
		$fbuser->name = $user['name'];
		$fbuser->link = $user['link'];
		$fbuser->about = $user['about'];
		$fbuser->gender = $user['gender'];
		$fbuser->import_enabled = 0;
		$fbuser->export_enabled = 0;
		$fbuser->last_status_id = 0;
		$fbuser->save();
		
		Hub::redirect('/settings/services');
	}
	
	/**
	 * Deauthorizes a user from their Facebook account and deletes
	 * the information from the userfacebook MySQL table.
	 */
	public function deauthorize() {
		sess::require_login();
		$active_user = sess::getUser();

		if (!isset($_GET['s']) || $_GET['s'] != md5('zOmg4tehcoolz!' . $active_user->username) || !$active_user->has_facebook()) {
			return Hub::redirect('/settings/services');
		}

		$fbuser = ActiveRecord::find('Userfacebook_Model', "SELECT * FROM userfacebook WHERE user_id = {$active_user->id} LIMIT 1");
		
		if ($fbuser->is_loaded()) {
			$fbuser->delete();
		}
		
		return Hub::redirect('/settings/services');
	}
}