<?

/**
 * Prototype for a built-in messaging system. Not fully implemented,
 * but left here in case someone else wants to continue where we left off.
 *
 * Messages are stored in Redis using sorted sets. The sets are sorted by
 * the last message timestamp.
 */
class Messaging_Controller extends Controller {
	public $enable_session = true;
	public $template = 'template/main';
	
	/**
	 * Shows the message page index.
	 */
	public function index() {
		if (!$this->session->get('authenticated')) {
			View::respond_to('html', function () {
				return Hub::redirect('/login');
			});
			
			View::respond_to(array('json', 'xml'), function () {
				return Hub::http_error(403, "Not authorized");
			});
		}
		
		$r = RedisManager::connection();
		
		$active_user = sess::getUser();
		
		// Get # of users we've interacted with
		$num = $r->zcard("messages:user:{$active_user->id}");
		$users = array();
		$msg_count = array();
		
		if ($num) {
			$result = $r->zrevrange("messages:user:{$active_user->id}", 0, $num);
			
			foreach ($result as $user) {
				$_user = ActiveCache::find('User_Model', $user, 43200)->sql(
					"SELECT * FROM users WHERE id = $user LIMIT 1"
				);
				
				if ($_user->is_loaded()) {
					$users[] = $_user;
					
					$msg_count[$_user->id] = $r->llen("messages:user:{$active_user->id}:withuser:{$_user->id}");
				}
			}
		}
		
		$template = $this->template;
		View::respond_to('html', function () use($template, $users, $msg_count) {
			$view = new View('messages/index');
			$view->msg_users = $users;
			$view->msg_count = $msg_count;
			
			$template->content = $view->render();
			echo $template->render();
		});
		
		View::respond_to(array('json', 'xml'), function ($format) use($users, $msg_count) {
		
		});
	}
}