<?php

/**
 * IP address white/blacklisting. Probably not needed for Campustream
 * but its here just in case.
 */
class iprules {
	
	// array of specific IP's to whitelist if it is blocked
	// using the ip ranges below
	private static $whitelist = array(
		
	);
	
	/**
	 * IP ranges to block when trying to access Hub
	 * Returns a 403 Forbidden HTTP error to any IP in these ranges
	 * Format:
	 * array(
	 *		'ip address' => subnet mask
	 *		'192.168.0.0' => 24
	 * )
	 */
	private static $ip_ranges = array(
		
	);
	
	public static function allowed() {
		if(in_array($_SERVER['REMOTE_ADDR'], self::$whitelist)) {
			return true;
		}
		
		foreach(self::$ip_ranges as $ip=>$mask) {
			if(self::ip_in_network($_SERVER['REMOTE_ADDR'], $ip, $mask)) { 
				return false;
			}
		}
		
		return true;
	}

	private static function ip_in_network($ip, $net_addr, $net_mask) {
		if ($net_mask <= 0) { return false; }
		$ip_binary_string = sprintf("%032b", ip2long($ip));
		$net_binary_string = sprintf("%032b", ip2long($net_addr));
		return substr_compare($ip_binary_string, $net_binary_string, 0, $net_mask) === 0;
	}
}
?>