<?
include_once 'XML/Unserializer.php';

/**
 * Prototype of an RSS reader for the Imported News section.
 * Not currently in use on the site, but it should be a good
 * start.
 */
class rssreader {
	private $rss_data;
	private $xml;
	private $data;
	
	private $generators = array(
		'wordpress',
		'blogger'
	);
	
	/**
	 * Load a RSS feed and return a new rssreader object.
	 */
	public static function load($url) {
		$opts = array(
			'http' => array(
				'method' => 'GET',
				'timeout' => 5
			)
		);
		
		$context = stream_context_create($opts);
		$rss_data = file_get_contents($url, false, $context);

		if (strlen($rss_data)) {
			return new rssreader($rss_data);
		}
	}
	
	public function __construct($rss_data) {
		$this->rss_data = $rss_data;
		
		$opts = array(
			'complexType' => 'object'
		);
		
		$this->xml = &new XML_Unserializer($opts);
		
		$this->parse();
	}
	
	private function parse() {
		$result = $this->xml->unserialize($this->rss_data, false);
		if ($result) {
			$this->data = $this->xml->getUnserializedData();
		}
	}
	
	/**
	 * Get important information about this RSS feed
	 */
	public function get() {
		return $this->data->channel;
	}
	
	private function getGenerator() {
		foreach ($this->generators as $gen) {
			if (stristr($this->get()->generator, $gen)) {
				return $gen;
			}
		}
		
		return 'unknown';
	}
	
	public function __get($key) {
		switch ($key) {
			case 'generator': return $this->getGenerator();
			case 'posts': return $this->get()->item;
		}
		
		return parent::__get($key);
	}
}