<?

/**
 * Shortcuts to work with the current session object
 */
class sess {
	
	/**
	 * Get the currently active User_Model
	 */
	public static function getUser() {
		return Hub::$activecontroller->session->get_session_object();
	}
	
	/**
	 * Get the username of the active user
	 */
	public static function getUsername() {
		return self::getUser()->username;
	}
	
	/**
	 * Get the ID of the active user
	 */
	public static function getUserID() {
		return self::getUser()->id;
	}
	
	/**
	 * Is the given user the same as the active user?
	 *
	 * @param $user The user to compare to the active user
	 */
	public static function isActiveUser(User_Model $user) {
		return (self::is_logged_in() && self::getUserID() == $user->id);
	}
	
	/**
	 * Is the current user logged in?
	 */
	public static function is_logged_in() {
		if (Hub::$activecontroller->session != null) {
			return Hub::$activecontroller->session->get('authenticated');
		} else {
			return false;
		}
	}
	
	/**
	 * Helper function to require a user to login. Redirects to the
	 * login page if they are not.
	 */
	public static function require_login() {
		if (!self::is_logged_in()) {
			return Hub::redirect('/login');
			exit;
		}
	}
}