<?
require_once 'XML/Serializer.php';

/**
 * Helper class for dealing with XML
 */
class xml {

	/**
	 * Given an array, encode it as XML
	 *
	 * @param $array The array to encode
	 * @param $root The root element of the XML tree
	 * @param $name The name of each array item in the XML tree
	 */
	public static function encode_array($array, $root, $name) {
		foreach ($array as $i=>$val) {
			if ($val instanceof ActiveRecord) {
				$array[$i] = $val->limited_object(false);
			}
		}
		
		$options = array(
			"indent"    => "    ",
			"linebreak" => "\n",
			"typeHints" => false,
			"addDecl"   => true,
			"encoding"  => "UTF-8",
			"rootName"   => $root,
			"defaultTagName" => $name
		);
		
		$serializer = new XML_Serializer( $options );
    $serializer->serialize( $array );
    return $serializer->getSerializedData();
	}
	
	/**
	 * Encode an array as RSS feed
	 */
  public static function encode_rss($stories) {
    $options = array(
      "indent"    => "    ",
      "linebreak" => "\n",
      "typeHints" => false,
      "addDecl"   => true,
      "encoding"  => "UTF-8",
      "rootName"   => "rdf:RDF",
      "defaultTagName" => "item"
    );
    
    $data = array(
      'channel' => array(
        'title' => 'Campustream News',
        'link' => 'http://campustream.com',
        $stories
      )
    );
    
    $serializer = new XML_Serializer($options);
    if ($serializer->serialize($data)) {
      return $serializer->getSerializedData();
    }
	}
}