<?

/**
 * Fake model class that represents a news/event category. They are defined here
 * instead of being stored in a database.
 */
class Newseventcategory_Model /* extends ActiveRecord... or does it? */ {
	private static $categories = array(
		0 => array(
			'type' => 'imported',
			'name' => 'Imported News',
			'slug' => 'imported'
		),
		
		1 => array(
			'type' => 'news',
			'name' => 'General WPI News',
			'slug' => 'general'
		),
		
		2 => array(
			'type' => 'news',
			'name' => 'Greek Life',
			'slug' => 'greek'
		),
		
		3 => array(
			'type' => 'news',
			'name' => 'Academics',
			'slug' => 'academics'
		),
		
		4 => array(
			'type' => 'news',
			'name' => 'Sports',
			'slug' => 'sports'
		),
		
		5 => array(
			'type' => 'news',
			'name' => 'Club/Organization News',
			'slug' => 'club_organization'
		),
		
		6 => array(
			'type' => 'news',
			'name' => 'World News',
			'slug' => 'world'
		),
		
		7 => array(
			'type' => 'news',
			'name' => 'Miscellaneous',
			'slug' => 'misc'
		),
		
		8 => array(
			'type' => 'event',
			'name' => 'General WPI Events',
			'slug' => 'general'
		),
		
		9 => array(
			'type' => 'event',
			'name' => 'Greek Life',
			'slug' => 'greek'
		),
		
		10 => array(
			'type' => 'event',
			'name' => 'Academics',
			'slug' => 'academics'
		),
		
		11 => array(
			'type' => 'event',
			'name' => 'Sports',
			'slug' => 'sports'
		),
		
		12 => array(
			'type' => 'event',
			'name' => 'Club/Organization Events',
			'slug' => 'club_organization'
		),
		
		13 => array(
			'type' => 'event',
			'name' => 'Social Event',
			'slug' => 'social'
		),
		
		14 => array(
			'type' => 'event',
			'name' => 'Miscellaneous Events',
			'slug' => 'misc'
		),
	);
	
	/**
	 * Load a category with the given ID
	 */
	public function load($cat_id) {
		$this->id = $cat_id;
		
		foreach (self::$categories[$cat_id] as $key=>$val) {
			$this->$key = $val;
		}
	}
	
	/**
	 * Get a category with the given type
	 */
	public static function getByType($type) {
		$cats = array();
		foreach (self::$categories as $cat_id => $cat) {
			if ($cat['type'] == $type) {
				$cats[] = array(
					'id' => $cat_id,
					'name' => $cat['name'],
					'slug' => $cat['slug']
				);
			}
		}
		
		return $cats;
	}
	
	/**
	 * Get a category by its URL slug
	 */
	public static function getBySlug($type, $slug) {
		foreach (self::$categories as $id => $cat) {
			if ($cat['type'] == $type && $cat['slug'] == $slug) {				
				$model = new Newseventcategory_Model();
				$model->load($id);
				
				return $model;
			}
		}
	}
}