<?

/**
 * Facebook information about a single user
 */
class Userfacebook_Model extends ActiveRecord {
	public $table_name = 'userfacebook';
	public $columns = array('id', 'user_id', 'fb_id', 'username', 'access_token', 'name', 'link', 'about', 'gender', 'import_enabled', 'export_enabled', 'last_status_id');
	public $cache_keys = array( 'userfacebook/#' => 'id', 'userfacebook/user:#' => 'user_id' );
	public $has_one = array('user');
	public $has_many = array();
	public $public_columns = array();
	
	public function save() {
		ActiveCache::invalidate_keys_for($this);
		
		return parent::save();
	}
	
	public function __get($key) {
		switch ($key) {
			case 'website_formatted' :
				if(mb_strlen($this->website) > 0) {
					$website = '<a class="nav-link" rel="nofollow" target="_blank" href="'.str_replace(array('"', "'"), "", $this->website).'">';
					if(mb_strlen($this->website) > 30) {
						$website .= mb_substr($this->website, 0, 30)."...";
					} else {
						$website .= $this->website;
					}
					$website .= "</a>";
					return $website;
				} else {
					return '';
				}
		}
		
		return parent::__get($key);
	}
}