<?

/**
 * Twitter information about a single user
 */
class Usertwitter_Model extends ActiveRecord {
	public $table_name = 'usertwitter';
	public $columns = array('id', 'user_id', 'twitter_id', 'username', 'oauth_token', 'oauth_secret', 'name', 'website', 'bio', 'location', 'avatar_url', 'utc_offset', 'geo_enabled', 'profile_background_color', 'profile_text_color', 'profile_link_color', 'profile_sidebar_fill_color', 'profile_sidebar_border_color', 'profile_background_image_url', 'profile_background_tile', 'import_enabled', 'export_enabled', 'last_tweet_id');
	public $cache_keys = array( 'usertwitter/#' => 'id', 'usertwitter/user:#' => 'user_id' );
	public $has_one = array('user');
	public $has_many = array();
	public $public_columns = array();
	
	/**
	 * Load the user this info pertains to
	 */
	public function load_user() {
		if (!$this->user) {
			$user = ActiveCache::find('User_Model', $this->user_id, 43200)->sql(
				"SELECT * FROM users WHERE id = {$this->user_id} LIMIT 1"
			);
			
			if ($user->is_loaded()) {
				$this->add_relationship('user', $user);
			}
		}
	}
	
	public function save() {
		ActiveCache::invalidate_keys_for($this);
		
		return parent::save();
	}
	
	public function __get($key) {
		switch ($key) {
			case 'website_formatted' :
				if(mb_strlen($this->website) > 0) {
					$website = '<a class="nav-link" rel="nofollow" target="_blank" href="'.str_replace(array('"', "'"), "", $this->website).'">';
					if(mb_strlen($this->website) > 30) {
						$website .= mb_substr($this->website, 0, 30)."...";
					} else {
						$website .= $this->website;
					}
					$website .= "</a>";
					return $website;
				} else {
					return '';
				}
		}
		
		return parent::__get($key);
	}
}