<?

group('debug');

desc('Test sortedarray class');
task('sortedarray', function () {

	$sarray = new sortedarray();
	$sorter = function ($left, $right) {
		if ($left->name < $right->name) {
			echo "{$left->name} < {$right->name}\n";
			return -1;
		} elseif ($left->name == $right->name) {
			echo "{$left->name} = {$right->name}\n";
			return 0;
		} else {
			echo "{$left->name} > {$right->name}\n";
			return 1;
		}
	};
	
	$user1 = new User_Model();
	$user1->name = "Ryan LeFevre";
	
	$user2 = new User_Model();
	$user2->name = "Bryan Crabtree";
	
	$user3 = new User_Model();
	$user3->name = "Jason Donenfeld";

	$sarray->add($user2, $sorter);	
	$sarray->add($user1, $sorter);
	$sarray->add($user3, $sorter);
		
	print_r($sarray->result());

});

desc("Create imaginary comments for testing");
task('redistest_create', function () {
	$r = RedisManager::connection();
	
	echo "Starting...";
	for ($i = 0; $i < 1000; $i++) {
		$parent_id = rand(0, 100);
		
		$comment = new Commenttest_Model();
		$comment->posted_by = 1;
		$comment->news_id = 1;
		$comment->parent_id = $parent_id;
		$comment->content = md5(rand(0, 10000));
		$comment->time_posted = ActiveRecord::NOW();
		
		$comment->save();
		
		// original implementation
		$key = "newstest:1:comment_by_id:$parent_id";
		$r->lpush($key, $comment->id);
		
		// no memcache
		$nom_key = "newstest:1:comment:{$comment->id}";
		$r->hset($nom_key, "id", $comment->id);
		$r->hset($nom_key, "posted_by", $comment->posted_by);
		$r->hset($nom_key, "news_id", $comment->news_id);
		$r->hset($nom_key, "parent_id", $comment->parent_id);
		$r->hset($nom_key, "content", $comment->content);
		$r->hset($nom_key, "time_posted", $comment->time_posted);
		$r->hset($nom_key, "deleted", 0);
		
		// redis only
		if ($parent_id === 0) { continue; }
		
		// get a unique ID
		$hash = uniqid();
		$redh_key = "newstest:1:comment_by_hash:$hash";
		$r->lpush($redh_key, $hash);
		
		$red_key = "newstest:1:comment:$hash";
		$r->hset($red_key, "id", $comment->id);
		$r->hset($red_key, "posted_by", $comment->posted_by);
		$r->hset($red_key, "news_id", $comment->news_id);
		$r->hset($red_key, "parent_id", $comment->parent_id);
		$r->hset($red_key, "content", $comment->content);
		$r->hset($red_key, "time_posted", $comment->time_posted);
		$r->hset($red_key, "deleted", 0);
	}
	
	echo "Finished!";
});

desc("Stress test various comment implementations");
task("redistest", function () {
	$r = RedisManager::connection();
	
	// Original implementation
	$len = $r->llen("newstest:1:comment_by_id:0");
	if ($len) {
		$ids = $r->lrange($key, 0, $len);
		foreach ($ids as $id) {
			$comment = ActiveCache::find('Commenttest_Model', $id, 43200)->sql(
				"SELECT * FROM commenttests WHERE id = $id LIMIT 1"
			);
			
			$comment->orig_load_children();
		}
	}
	
});