<?

group('email');

desc('Email queue');
task('queue', function ($args) {
	
	$start = time();
	$runtime = 290;
	$queue_name = 'queue:email';
	
	$r = RedisManager::connection();
	
	while (($start + $runtime) > time()) {
		if ($r->llen($queue_name) === 0) {
			sleep(5);
			continue;
		}
		
		$data = $r->lpop($queue_name);
		if (!$data) {
			sleep(2);
			continue;
		}
		
		$data = unserialize($data);
		email::send($data['to'], $data['subject'], $data['body']);
	}
});

desc('Resend confirmation email');
task('resend_confirm', function ($args) {

	force_execution_on( any_web_server );

	$username = array_shift($args);
	$user = ActiveRecord::find('User_Model', "SELECT * FROM users WHERE username = '$username' LIMIT 1");
	if (!$user->is_loaded()) {
		echo "ERROR: user not found\n";
		return;
	}
	
	email::send_confirmation($user);
	echo "Confirmation email resent!\n";
});

desc('Print out all emails in a copy & pasteable format');
task('print_all', function () {
	$users = ActiveRecord::find_all("User_Model", "SELECT * FROM users");
	foreach($users as $user) {
		echo $user->email . "; ";
	}
});