<?php

group('memcache');

desc('Flushes the entire Twitpic cache');
task('flush', function($args) {

	$memcache = MemcacheManager::connection();
	
	echo "Flushing all items from cache...\n";
	$memcache->flush();
	
});

desc('Shows which Memcache servers are online and which ones are offline');
task('status', function() {

	$memcache = MemcacheManager::connection();

	$online   = $memcache->getStats();
	
	include "{$GLOBALS['APPROOT']}application/config/memcache.php";
	
	foreach( $config as $name => $server ) {
		
		echo str_pad( "{$name} ({$server['host']}): ", 23);
		
		$key = "{$server['host']}:{$server['port']}";
		echo ( isset( $online[$key] ) ? "ONLINE\n" : "OFFLINE\n" );
	}

	

});

desc('Delete a single memcache key');
task('delete', function($args) {
	
	force_execution_on(any_web_server);
	
	$key = array_shift( $args );
	if(strlen($key) == 0){ return false; }
	
	$memcache = MemcacheManager::connection();
	
	echo "Deleting cache key: $key\n";
	
	$memcache->delete( $key );
	
});

desc('Retrieves the data stored at a single memcache key');
task('get', function($args) {
	
	force_execution_on(any_web_server);
	
	$key = array_shift( $args );
	if(strlen($key) == 0){ return false; }
	
	$memcache = MemcacheManager::connection();
	
	echo "Retrieving cache key: $key\n";
	
	$data = $memcache->get( $key );
	
	print_r($data);
	
});