<?

group('twitter');

desc('Status message queue');
task('status_queue', function ($args) {
	
	$start = time();
	$runtime = 290;
	$status_queue = 'queue:twitter:statuses';
	
	$r = RedisManager::connection();
	
	while (($start + $runtime) > time()) {
		if ($r->llen($status_queue) === 0) {
			sleep(5);
			continue;
		}
		
		$data = $r->lpop($status_queue);
		if (!$data) {
			sleep(2);
			continue;
		}
		
		$data = unserialize($data);
		$user = ActiveCache::find('User_Model', $data['user'], 43200)->sql(
			"SELECT * FROM users WHERE id = {$data['user']} LIMIT 1"
		);
		
		if (!$user->is_loaded()) {
			continue;
		}
		
		if (!$user->has_twitter() || $user->twitter()->export_enabled == 0) {
			continue;
		}
		
		$twitter = $user->twitter_api();
		$message = mb_substr($data['payload'], 0, 140);
		$resp = $twitter->post('statuses/update', array('status' => $message));
		if ($resp && $twitter->http_code === 200) {
			$user->twitter()->last_tweet_id = $resp->id_str;
			$user->twitter()->save();
			
			Logger::tweet_export("Posted status update for {$user->username} to @{$user->twitter()->username}");
		} elseif ($twitter->http_code >= 500) {
			Logger::tweet_export("Error for {$user->username}: {$twitter->http_code}");
			Logger::tweet_export($twitter->http_info);
			$r->rpush($status_queue, serialize($data));
		} else {
			Logger::tweet_export("Error for {$user->username}: {$twitter->http_code}");
		}
	}
});