<div id="home-wrap">
	<div id="content-left" class="question-wrap">
		<h1>
			<a href="/collaborate">Collaborate</a> &raquo; 
			<a href="/collaborate/<?=$question->category?>/"><?=ucfirst($question->category)?></a>
		</h1>
		
		<div id="question-header">
			<div id="question-header-avatar">
				<img src="<?=$question->user->avatar?>" />
			</div>
			<div id="question-header-content">
				<h1><?=$question->title?></h1>
				<p id="question-content"><?=$question->message?></p>
				<div class="question-tags">
					<? if($question->tags && count($question->tags) > 0): foreach($question->tags as $tag): ?>
					<span class="question-tag"><?=$tag->tag?></span>
					<? endforeach; endif; ?>
				</div>
				<div id="question-header-meta">
					Asked <?=date::relative_time($question->post_date)?> by <a href="/user/<?=$question->user->username?>"><?=$question->user->name?></a>
					
					<? if (sess::is_logged_in() && $question->user_id == sess::getUserID()): ?>
					&bull; <span id="<?=$question->id?>-delete-question" class="delete-question link">Delete</span>
					<? endif; ?>
				</div>
			</div>
			<div style="clear:both"></div>
			
			<div id="question-attachments">
				<h1>Question Attachments</h1>
				<div id="question-media"></div>
			</div>
		</div>
		
		<div id="question-response-wrap">
			<h2><?=count($question->responses)?> <?=vocab::plural("Response", count($question->responses))?></h2>
			<div id="question-responses">
			<? foreach($question->responses as $response): ?>
			<? $response->load_user(); ?>
			<?
				$has_voted = $response->has_voted();
				$up_votes = $response->up_votes;
				$down_votes = $response->down_votes;
			?>
			
				<div id="response-<?=$response->id?>" class="response-wrap">
					<div class="response-image">
						<img src="<?=$response->user->avatar_url('small')?>" />
					</div>
					<div class="response-content">
						<p><?=$response->message?></p>
						<div class="response-meta">
							<a href="/user/<?=$response->user->username?>"><?=$response->user->name?></a> replied <?=date::relative_time($response->post_date)?> &bull;
							<span class="voting-details"><?=$up_votes?> up <?=vocab::plural('vote', $up_votes)?>, <?=$down_votes?> down <?=vocab::plural('vote', $down_votes)?></span>
						</div>
					</div>
					<div class="response-voting">
						<div class="vote-up <?=$has_voted === 'up' ? 'active' : ''?>"></div>
						<div class="vote-count <?=$has_voted != false ? 'active' : ''?>"><?=$response->vote_count?></div>
						<div class="vote-down <?=$has_voted === 'down' ? 'active' : ''?>"></div>
					</div>
					<div style="clear:both"></div>
					<div class="response-attachments">
						<h1>Response Attachments</h1>
						<div class="response-media"></div>
					</div>
				</div>
			<? endforeach; ?>
			</div>
			
			<div id="question-respond-wrap">
				<h2>Reply to this question</h2>
				<textarea id="question-respond-input"></textarea>
				<div class="collaborate-submit">
					<span>Broadcast to:</span>
					<input name="question-public" type="radio" value="1" checked="true" /> <label for="public">Everyone</label>
					<input name="question-public" type="radio" value="0" /> <label for="public">Followers Only</label>
					<input name="question-public" type="radio" value="2" /> <label for="public">Question Asker Only</label>
					
					<input id="collaborate-submit" type="button" class="fancy-button-blue" value="Post Response" />
				</div>
			</div>
		</div>
	</div>
	
	<div id="content-right">
		<?=View::factory('template/_sidebar')->set('user', sess::getUser())->render()?>
	</div>

	<div style="clear:both;"></div>
</div>