<!DOCTYPE html>
<html lang="en">
<head>
	<title>Campustream</title>
	
	<link href="http://fonts.googleapis.com/css?family=Lobster:regular&subset=latin" rel="stylesheet" type="text/css" >
	<link type="text/css" rel="stylesheet" href="/css/reset.css" />
	<link type="text/css" rel="stylesheet" href="/css/wait.css" />
	
	<script type="text/javascript" src="/js/head.js"></script>
	<script type="text/javascript">
	head.js(
		{jquery: "https://ajax.googleapis.com/ajax/libs/jquery/1.4.3/jquery.min.js"},
		{confirm: "/js/confirm.js"}
	);
	</script>
</head>
<body>
  <!-- Survey modal box -->
  <div id="modal-bg" style="display: none">
    <div id="modal-wrap">
    <div id="modal-title">Campustream MQP Survey</div>
    <div id="modal-content">
      <p>Before finishing your registration with Campustream, please note that Campustream has been built as part of a Computer Science MQP at WPI. Our main goal is to study and understand student preferences and behaviors. Data shall be gathered and analyzed scientifically.</p>
      <p>All collected information will be kept confidential. This MQP and our data gathering methodology has approval from the Institutional Review Board (IRB) and follows its requirements.</p>
      
      <p>With collected data...</p>
      
      <p>we will:</p>
      <ul>
        <li>Use data only in aggregate/statistics form and no names or personal information shall be used except in aggregate/statistics form.</li>
        <li>Convert collated data into summary graphs for visualization purposes</li>
        <li>Discuss observed trends and outliers of the data</li>
        <li>Use the (non-identifying) data in the final report for this MQP</li>
      </ul>
      
      <p>we will <b>not</b>:</p>
      <ul>
        <li>Reveal or discuss any personally identifiable information</li>
        <li>Use your name or email address in any part of the analysis (unless we contact you and are given explicit permission)</li>
        <li>Give or show the raw survey data to anyone except for the members of the Campustream team and our advisor</li>
      </ul>
      
      <p>To get a feel for the current situation before Campustream was released, it would help us greatly if you could take a really short survey.</p>
      <p>Of course, if you do not wish to take this survey, you may disregard this message and begin using Campustream.</p>
      
      <div id="modal-actions">
        <input id="survey-close" class="fancy-button-grey" type="button" value="Opt-Out and Close" />
        <input id="survey-open" class="fancy-button-blue" type="button" value="Agree and Open Survey" />
      </div>
     </div>
    </div>
  </div>
  
  <!-- End survey modal box -->
  
	<div id="header">
		<h1><a href="/">Campustream</a></h1>
	</div>
	
	<div id="content-wrap">
		<div id="content">
			<p>Whoa there, buddy.  Before you use Campustream, you'll need to confirm your email address.</p>
			<p>An email with a confirmation link has been sent to:</p>
			
			<div id="confirm-email"><?=$user->email?></div>
			
			<div id="controls">
				<input id="logout-button" type="button" class="fancy-button-grey" value="Logout" />
				<input id="enter-code" type="button" class="fancy-button-blue" value="Enter Code" />
			</div>
			
			<div class="other-actions">
				Didn't get the email? <a href="mailto:ryan@campustream.com">Let me know.</a>
			</div>
		</div>
  </div>
</body>
</html>