<?=
	View::factory('news/_navbar')->
		set('type', $news->category->type)->
		set('category', $news->category)->
		set('sorting', false)->
		render()
?>

<? $has_voted = $news->has_voted(); ?>
<div id="news-wrap">

	<div id="content-left">
		<? if($_GET['new']): ?>
		<div id="news-new-notification">
			<p>Here is your new post! Please note that it may take up to 5 minutes for it to be listed on the site.</p>
		</div>
		<? endif; ?>
		
		<div id="news_<?=$news->id?>" class="news-content-wrap">
			<div class="news-vote-wrap">
				<div class="vote-up <?=$has_voted == 'up' ? 'active' : ''?>"></div>
				<div class="vote-count <?=$has_voted ? 'active' : ''?>"><?=$news->votes?></div>
				<div class="vote-down <?=$has_voted == 'down' ? 'active' : ''?>"></div>
			</div>

			<div class="news-content">
				<h1><a target="_blank" href="<?=$news->type == 'link' ? $news->post : '#'?>"><?=$news->title?></a></h1>
				<div class="news-meta">
					<p><?=ucwords($news->category->type)?> &mdash; <?=$news->upvotes?> upvotes, <?=$news->downvotes?> downvotes</p>
					<p><?=ucwords($news->type)?> submitted by <a href="/user/<?=$news->user->username?>"><?=$news->user->name?></a> to <a href="/<?=$news->category->type?>/<?=$news->category->slug?>"><?=$news->category->name?></a> <?=date::relative_time($news->time_posted)?></p>
				</div>
			</div>

			<div style="clear: both"></div>
			<? if ($news->category->type == 'event' && $news->eventmeta): ?>
			<div id="event-meta">
				<h1>Event Information</h1>
				
				<? if ($news->eventmeta->location): ?>
					<h2>Where</h2>
					<p><?=$news->eventmeta->location?></p>
					<p><small><?=is_numeric($news->eventmeta->location_area) ? 'Room' : ''?> <?=$news->eventmeta->location_area?></small></p>
				<? endif; ?>
				
				<? if (strtotime($news->eventmeta->start_date) > 0 || $news->eventmeta->all_day): ?>
					<h2>When</h2>
					<? if ($news->eventmeta->all_day): ?>
						<p>Event runs all day <?=date::relative_time($news->eventmeta->start_date)?></p>
					<? else: ?>
						<p>Event starts <?=date::relative_time($news->eventmeta->start_date)?></p>
						<p><small>
						<? if(strtotime($news->eventmeta->start_date) > 0): ?>
							From <?=date('F j, Y g:ia', strtotime($news->eventmeta->start_date))?> 
						<? endif; ?>
						<? if(strtotime($news->eventmeta->end_date) > 0): ?>
							to <?=date('F j, Y g:ia', strtotime($news->eventmeta->end_date))?></small></p>
						<? else: ?>
							onwards
						<? endif; ?>
					<? endif; ?>
				<? endif; ?>
			</div>
			<? endif; ?>
			
			<? if ($news->type == 'text'): ?>
			<div style="clear:both"></div>
			<div id="news-content-text">
				<?=bbparser::bb2html($news->post)?>
			</div>
			<? endif; ?>
						
			<div style="clear:both"></div>
		</div>
		
		<div id="news-comments-wrap">
			<h1><?=$news->num_comments?> <?=vocab::plural('Comment', $news->num_comments)?></h1>
			
			<div id="outer-comment-wrap">
				<?=View::factory('news/_comments')->set('comments', $news->comments)->render(); ?>
			</div>
			
			<div id="reply-to-0" class="news-comment-reply-to" style="display: block">
				<textarea class="news-comment-reply"></textarea>
				<div class="comment-reply-button">
					<input type="button" class="fancy-button-blue" value="Post Comment" />
				</div>
			</div>
		</div>
	</div>
	
	<div id="content-right">
		<? if (sess::is_logged_in()): ?>
			<?=View::factory('template/_news_sidebar_auth')->render()?>
		<? else: ?>
			<?=View::factory('template/_news_sidebar_unauth')->render()?>
		<? endif; ?>
	</div>

	<div style="clear:both;"></div>
</div>