<!DOCTYPE html>
<html lang="en">
<head>
	<title>Campustream - Update from <?=$status->user->name?></title>
	
	<link type="text/css" rel="stylesheet" href="/css/reset.css" />
	<link href="http://fonts.googleapis.com/css?family=Lobster:regular&subset=latin" rel="stylesheet" type="text/css" >
	<link type="text/css" rel="stylesheet" href="/css/single.css" />
</head>
<body>
	<div id="header">
		<h1><a href="/">Campustream</a></h1>
	</div>
	
	<div id="content-wrap">
		<div id="content">
			<p>
			<? if($status->type == 'question'): ?>
				<?=$status->user->name?> asked: <?=$status->message?>
			<? elseif($status->type == 'response'): ?>
				<?=$status->user->name?> replied: <?=$status->message?>
			<? else: ?>
				<?=$status->message?>
			<? endif; ?>
			</p>
			<div id="post-time">posted <?=date::relative_time($status->post_date)?></div>
		</div>
		<div id="content-meta">
			<div id="user-avatar">
				<img src="<?=$status->user->avatar_url('small')?>" />
			</div>
			<div id="user-info">
				<h1><a href="/user/<?=$status->user->username?>"><?=$status->user->name?></a></h1>
				<p><?=$status->user->summary?></p>
				<p>Followers: <?=$status->user->followers_count()?> &mdash; Following: <?=$status->user->follows_count()?></p>
			</div>
		</div>
		<div style="clear:both"></div>
		
		<? if ($status->content): ?>
		<div id="content-extra-wrap">
			<?=
				View::factory("statuses/_single_{$status->type}")->
					set('content', $status->content)->
					set('status', $status)->
					render()
			?>
		</div>
		<? endif; ?>
		
		<? if (count($status->comments) > 0): ?>
		<div id="comments-wrap">
			<h1>Comments</h1>
			
			<? foreach($status->comments as $comment): ?>
			<div class="comment-wrap">
				<div class="comment-avatar">
					<img src="<?=$comment->user->avatar_url('small')?>" />
				</div>
				<div class="comment-content">
					<a href="/user/<?=$comment->user->username?>"><?=$comment->user->name?></a> <?=$comment->message?>
				</div>
				
				<div style="clear:both"></div>
			</div>
			<? endforeach; ?>
		</div>
		<? endif; ?>
	</div>
</body>
</html>