<?php


class Controller {
	
	public $enable_session = false;
	public $template;
	
	public $session = null;
	
	public function __construct() {
		if (Hub::$activecontroller == NULL) {
			# Set the active controller to the first controller loaded
			Hub::$activecontroller = $this;
		}
		
		if ($this->enable_session) {
			if (isset($_POST['access_token'])) {
				$this->session = Session_Controller::rebuild_using_access_token($_POST['access_token']);
			} else {
				$this->session = new Session();
			}
		}
				
		if(isset($this->template) && !empty($this->template)) {
			$this->template = new View( $this->template );
		}
		
	}
	
	public function __call($method, $args) {
		# METHOD NOT FOUND, THROW A 404
		echo "Could not find $method -> $args<br>";
		Hub::send404();
	}
	
	public function _loadView($filename, $data) {
		
		extract($data);

		ob_start();
		include($GLOBALS['APPROOT'] . 'application/views/' . $filename);
		$rendered = ob_get_contents();
		ob_end_clean();
        return $rendered;
	}
}