<?php

class DatabaseManager {
	
	protected static $conwrite 	= null;
	protected static $conread 	= null;
	
	public static function connect($server_array=null) {
		
		if ( empty($server_array) || ( ! is_array($server_array) ) ) {
			require($GLOBALS['APPROOT'] . 'application/config/database.php');
			foreach($slaves as &$config) {
				$config = array_merge($default, $config);
			}
			unset($config);
			
			$server_array = array_merge($default, $master);
		}
		
		$con = self::realconnect( array(
			'host' => $server_array['host'],
			'user' => $server_array['user'],
			'pass' => $server_array['pass'],
			'db'   => $server_array['db']
		));
		
		$con->query("SET NAMES 'utf8'");
		
		return $con;
		
	}
	
	public static function realconnect($args) {
		return new mysqli($args['host'], $args['user'], $args['pass'], $args['db']);
	}
	
	public static function writeConnection() {
		
		if (self::$conwrite !== null && mysqli_ping(self::$conwrite)) return self::$conwrite;
		
		$connection = DatabaseManager::connect();
		self::$conwrite = $connection;
		
		return $connection;
		
	}
	
	public static function readConnection() {
		
		if( self::$conread !== null && mysqli_ping(self::$conread)) return self::$conread;
		
		$connection = DatabaseManager::connect( self::selectSlave() );
		self::$conread = $connection;
		
		return $connection;
		
	}
	
	public static function selectSlave() {
		
		require($GLOBALS['APPROOT'] . 'application/config/database.php');
		foreach($slaves as &$config) {
			$config = array_merge($default, $config);
		}
		unset($config);
		
		foreach($slaves as $host => $config) {
			if ( $config['enabled'] === false ) unset($slaves[$host]);
		}
		
		return $slaves[array_rand($slaves)];
		
	}
	
	public static function escape($data) {
		$con = self::writeConnection();
		return $con->real_escape_string($data);
	}
	
}