<?php

// ImmutableSession is used to create a read-only non-modifiable session. It is used by
// the API to authenticate method calls using an OAuth or PIN Authentication. It silently
// ignores all writes.

class ImmutableSession {
	
	public $sess_object = '';
	private $sess_user = null;
	
	public function __construct($user) {
		require($GLOBALS['APPROOT'] . 'application/config/sessions.php');
		$this->sess_object = $SESSION_OBJECT;
		
		$this->sess_user = $user;
	}
	
	public function get_session_object() {
		return $this->sess_user;
	}
	
	public function get($key) {
		return $this->__get($key);
	}
	
	public function set($key, $value) {
		return $this->__set($key, $value);
	}
	
	public function __set($key, $value) {
		return;
	}
	
	public function __get($key) {
		return ($key == "authenticated") ? true : null;
	}
	
}