<?php


class Router {
	
	public static function process() {

		if(isset($_GET['hub_uri']) && $_GET['hub_uri']) {
			$uri = trim($_GET['hub_uri'], '/');
		} else {
			$uri = '_default';
		}
		
		$routes = Router::loadRoutes();
		
		# STATIC URI MATCHING
		if(isset($routes[$uri])) {
			
			$routed_uri = $routes[$uri];
			
		# REGEX URI MATCHING
		} else {
		  
			foreach($routes as $key=>$val) {
				
				if (preg_match('#^'.$key.'$#u', $uri)) {
					if (strpos($val, '$') !== FALSE) {
						# Use regex routing
						$routed_uri = preg_replace('#^'.$key.'$#u', $val, $uri);
					} else {
						# Standard routing
						$routed_uri = $val;
					}

					# A valid route has been found
					break;
				}
				
			}
		
		}

		if(isset($routed_uri)) {

			$folders = explode( '.', $routed_uri );
			
			$path = null;
			
			if ( count($folders) > 1 ) {
				$routed_uri = array_pop($folders);
				$path = join('/', $folders );
			}
		
			$uriparts = explode('/', $routed_uri);
			$controller = $uriparts[0];
			$method = ( $uriparts[1] != '' ? $uriparts[1] : 'index' );
		
			for($i=1;$i<=2;$i++) array_shift($uriparts);
		
			foreach($uriparts as $value) {
				$aparts = explode(':', $value);
				$args[$aparts[0]] = $aparts[1];
			}

			if(substr($method,0,1) == '_') {
				echo "Error - access to hidden methods not allowed";
				die();
			}
			
			$router_args = array( 'path' => $path, 'controller' => $controller, 'method' => $method, 'args' => $args );
			
			self::statistics( $router_args );

			Router::run( $router_args );
		
		} else {

			# THROW AN ERROR (404)
			Hub::send404();
		}
		
	}
	
	private static function statistics($info) {
		// In order to avoid multiple views for the same page
		if (Hub::is_ajax()) { return; }
		
		extract($info);
		
		$r = RedisManager::connection();
		
		$format = Hub::$response_format;
		
		$key = "stats:$controller:$method:$format:page_views";
		if (!(bool)$r->exists($key)) {
		    $r->rpush("stats:by_method", serialize(array('controller' => $controller, 'method' => $method, 'format' => $format)));
		}
		
		$r->incr($key);
		$r->incr('stats:total_views');
		$r->sadd("stats:ips", $_SERVER['REMOTE_ADDR']);
		$r->incr("stats:by_ip:{$_SERVER['REMOTE_ADDR']}");

	}
	
	public static function run($args) {

		$cname = $args['controller'] . '_Controller';
		$mname = $args['method'];
		
		if ( $args['path'] !== null ) {
			include "{$GLOBALS['APPROOT']}application/controllers/{$args['path']}/{$args['controller']}.php";
		}
		
		// HACK HACK HACK HACK
		// for backwards compatability, pass the format to the controller as an arg
		$args['args']['format'] = Hub::$response_format;
		// HACK HACK HACK HACK
		
		$controller = new $cname;
		$controller->$mname($args['args']);
		
	}
	
	public static function loadRoutes() {
		require( $GLOBALS['APPROOT'] . 'application/config/routes.php' );
		
		return $config;
	}
	
}