<?php


class View {
	
	protected $local_data = array();
	protected static $global_data = array();
	
	private $filename;
	
	function __construct($name, $data = null) {
		
		$this->filename = $name . '.php';
		
		if (is_array($data) AND !empty($data)) {
			$this->local_data = array_merge($this->local_data, $data);
		}
		
	}
	
	public static function factory($name, $data = null) {
		return new View($name, $data);
	}
	
	function render() {
		
		$data = array_merge(View::$global_data, $this->local_data);
		
		$output = Hub::$activecontroller->_loadView($this->filename, $data);
		return $output;
		
	}
	
	function set($name, $value) {
		$this->__set($name, $value);
		return $this;
	}
	
	function __set($name, $value) {
		$this->local_data[$name] = $value;
		View::$global_data[$name] = $value;
	}
	
	function __get($key) {
		if (isset($this->local_data[$key]))
			return $this->local_data[$key];

		if (isset(View::$global_data[$key]))
			return View::$global_data[$key];

		if (isset($this->$key))
			return $this->$key;
	}
	
	// gives controllers the ability to have format-specific code that only runs
	// when the given format is requested. the format can be a string or array

	public static function respond_to( $format, $block ) {

	  if ( is_array( $format ) ) {
	    foreach( $format as $extension ) {
	      View::respond_to( $extension, $block );
	    }

	    return;
	  }

	  if ( $format === Hub::$response_format ) {

	    isset( Hub::$mime_types[$format] ) ? header( "Content-Type:" . Hub::$mime_types[$format] ) : null;

	    $block($format);
	  }

	}
	
}