# Campustream

Note: this is a Markdown document. I recommend posting it to gist.github.com for better readability.

The purpose of this Major Qualifying Project was to create a social network with a strong mobile component focused on academia, collaboration, and campus events. Campustream consists of a website and an Android application that allows students to post interesting news stories, upcoming events, academic or social questions, and general status updates. Many of the features in Campustream can be voted on in order to determine a particular items popularity. The web application is primarily implemented with PHP, and the Android application is implemented in Java. The current work done on Campustream was also meant to lay a stable foundation for future projects to build on top of.

## Getting Campustream Running

This guide assumes you are using Ubuntu Server, preferably version 10.10 or later, to run Campustream.

### Webserver Setup

This section of the setup is for getting the web server working. You may setup the database on the same server as the webserver, but this is not recommended for smaller servers due to scalability reasons.

First off, lets add the user for hosting the website:

	adduser campustream_com
	
Simply enter the default values for all of the questions. Once the user is added and the corresponding home directory is created, add the folder:

	mkdir /home/campustream_com/public_html

And copy all of Campustream into it. This is where the website will be hosted from.

Next, lets install as many components as possible using Apt:

	apt-get install build-essential python-software-properties memcached php5-cli php5-fpm php5-xcache php5-dev php5-mysql php5-mcrypt
	
Running this will probably report an error at the end regarding php5-fpm. You can ignore this, we'll fix it soon below.

Now, lets add the Nginx repository and install Nginx:

	add-apt-repository ppa:nginx/stable
	apt-get update
	apt-get install nginx
	
Once that is finished, copy the following files from the server_configs folder onto the server at the destination:

	server_configs/				=> server destination

	php/php.ini						=> /etc/php5/fpm/php.ini
	php/campustream.conf	=> /etc/php5/fpm/pool.d/campustream.conf
	
	nginx/nginx.conf			=> /etc/nginx/nginx.conf
	nginx/fastcgi_params	=> /etc/nginx/fastcgi_params
	nginx/campustream_com	=> /etc/nginx/sites-enabled/campustream_com
	
	memcached/memcached.conf	=> /etc/memcached.conf
	
Finally, we're going to need to install Thrift on the webserver. The installation for Thrift is a bit tricker, but there are plenty of guides out there for reference. Unfortunately, FlockDB is a bit finicky at the time of this writing, and it requires thrift-0.2.0. This version has been included in the server_configs folder for you.

Once all of that is finished, the web server should be (almost) ready to go. There are some final steps to complete once the database server is setup below.

### Database Server Setup

This section of the setup is for getting the database server setup. As mentioned above, this can optionally be installed on the same server as the webserver, although this isn't recommended.

First up, lets install everything we can with Apt:

	apt-get install build-essential mysql-server mysql-client memcached redis-server
	
Unfortunately, the rest we have to install manually. Included in the server_configs folder is a FlockDB archive for your convenience. You will first need to get gizzard and gizzmo before attempting to install it.

You can download and install Sphinx from its official website. The latest (beta) version is recommended.

Copy the files:
	
	server_configs/						=> server destination
	
	redis/redis.conf					=> /etc/redis/redis.conf
	memcached/memcached.conf	=> /etc/memcached.conf
	mysql/my.cnf							=> /etc/mysql/my.cnf
	
And update the memcached configuration to set the local network IP on the database server (if its a separate server than the webserver). Update the Redis configuration as well.
	
### Final Configuration

On the webserver, add the cronjobs for the queue workers:

	*/5 * * * * /home/campustream_com/public_html/hubcap twitter:status_queue
	*/5 * * * * /home/campustream_com/public_html/hubcap facebook:status_queue
	*/5 * * * * /home/campustream_com/public_html/hubcap email:queue

I recommend adding them to the cronjob for user campustream_com and not root.