-- phpMyAdmin SQL Dump
-- version 3.3.8
-- http://www.phpmyadmin.net
--
-- Host: 10.179.65.133
-- Generation Time: Apr 30, 2011 at 08:40 PM
-- Server version: 5.1.49
-- PHP Version: 5.3.3-1ubuntu9.3

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `campustream`
--

-- --------------------------------------------------------

--
-- Table structure for table `eventmeta`
--

CREATE TABLE IF NOT EXISTS `eventmeta` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `event_id` mediumint(8) unsigned NOT NULL,
  `location` varchar(200) NOT NULL,
  `location_area` varchar(200) NOT NULL,
  `start_date` datetime NOT NULL,
  `end_date` datetime NOT NULL,
  `all_day` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `event_id` (`event_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=18 ;

-- --------------------------------------------------------

--
-- Table structure for table `newscomments`
--

CREATE TABLE IF NOT EXISTS `newscomments` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `posted_by` mediumint(8) unsigned NOT NULL,
  `news_id` mediumint(9) unsigned NOT NULL,
  `parent_id` mediumint(9) unsigned NOT NULL,
  `content` text NOT NULL,
  `time_posted` datetime NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `news_id` (`news_id`),
  KEY `poster_id` (`posted_by`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=28 ;

-- --------------------------------------------------------

--
-- Table structure for table `newsevents`
--

CREATE TABLE IF NOT EXISTS `newsevents` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` enum('link','text','imported') NOT NULL,
  `category_id` tinyint(3) unsigned NOT NULL,
  `newsevent` enum('news','event') NOT NULL,
  `title` varchar(200) NOT NULL,
  `post` text NOT NULL,
  `posted_by` int(10) unsigned NOT NULL,
  `time_posted` datetime NOT NULL,
  `votes` int(11) NOT NULL,
  `num_comments` mediumint(8) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`category_id`),
  KEY `posted_by` (`posted_by`),
  KEY `time_posted` (`time_posted`),
  KEY `newsevent` (`newsevent`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=24 ;

-- --------------------------------------------------------

--
-- Table structure for table `newsimports`
--

CREATE TABLE IF NOT EXISTS `newsimports` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `site_name` varchar(120) NOT NULL,
  `site_url` varchar(200) NOT NULL,
  `site_rss` varchar(200) NOT NULL,
  `last_import_id` mediumint(8) unsigned NOT NULL,
  `last_import_time` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `questions`
--

CREATE TABLE IF NOT EXISTS `questions` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `category` enum('academic','social','misc','happenings') NOT NULL,
  `title` varchar(140) NOT NULL,
  `message` text NOT NULL,
  `post_date` datetime NOT NULL,
  `last_update` datetime NOT NULL,
  `vote_count` smallint(5) unsigned NOT NULL,
  `is_public` tinyint(1) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`category`),
  KEY `vote_count` (`vote_count`),
  KEY `last_update` (`last_update`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=11 ;

-- --------------------------------------------------------

--
-- Table structure for table `questiontags`
--

CREATE TABLE IF NOT EXISTS `questiontags` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `question_id` int(10) unsigned NOT NULL,
  `tag` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `question_id` (`question_id`,`tag`),
  KEY `tag` (`tag`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=38 ;

-- --------------------------------------------------------

--
-- Table structure for table `responses`
--

CREATE TABLE IF NOT EXISTS `responses` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `question_id` int(10) unsigned NOT NULL,
  `user_id` int(10) unsigned NOT NULL,
  `message` text NOT NULL,
  `post_date` datetime NOT NULL,
  `vote_count` smallint(5) NOT NULL,
  `is_public` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `question_id` (`question_id`),
  KEY `vote_count` (`vote_count`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=31 ;

-- --------------------------------------------------------

--
-- Table structure for table `statuscomments`
--

CREATE TABLE IF NOT EXISTS `statuscomments` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `status_id` int(10) unsigned NOT NULL,
  `message` text NOT NULL,
  `post_date` datetime NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`,`status_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=56 ;

-- --------------------------------------------------------

--
-- Table structure for table `statuses`
--

CREATE TABLE IF NOT EXISTS `statuses` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL,
  `source` enum('site','api','twitter','facebook') NOT NULL,
  `message` text NOT NULL,
  `post_date` datetime NOT NULL,
  `type` enum('text','link','question','response','newsevent','newscomment') NOT NULL,
  `content_id` int(10) unsigned NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  `is_public` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`,`deleted`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=131 ;

-- --------------------------------------------------------

--
-- Table structure for table `userfacebook`
--

CREATE TABLE IF NOT EXISTS `userfacebook` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(11) unsigned NOT NULL,
  `fb_id` int(10) unsigned NOT NULL,
  `username` varchar(100) NOT NULL,
  `access_token` varchar(200) NOT NULL,
  `name` varchar(200) NOT NULL,
  `link` varchar(200) NOT NULL,
  `about` text NOT NULL,
  `gender` enum('male','female') NOT NULL,
  `import_enabled` tinyint(1) NOT NULL,
  `export_enabled` tinyint(1) NOT NULL,
  `last_status_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`fb_id`),
  UNIQUE KEY `fb_id` (`fb_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=22 ;

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE IF NOT EXISTS `users` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(120) NOT NULL,
  `name` varchar(200) NOT NULL,
  `email` varchar(200) NOT NULL,
  `password` varchar(120) NOT NULL,
  `join_date` datetime NOT NULL,
  `has_avatar` tinyint(1) NOT NULL,
  `avatar_format` varchar(3) NOT NULL,
  `current_status` int(10) NOT NULL,
  `bio` varchar(160) NOT NULL,
  `website` varchar(160) NOT NULL,
  `college_majors` varchar(120) NOT NULL,
  `college_minors` varchar(120) NOT NULL,
  `class_year` int(10) unsigned NOT NULL,
  `karma` int(11) NOT NULL,
  `confirmed` tinyint(1) NOT NULL,
  `confirm_code` varchar(200) NOT NULL,
  `email_enabled` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`),
  KEY `karma` (`karma`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=208 ;

-- --------------------------------------------------------

--
-- Table structure for table `usertwitter`
--

CREATE TABLE IF NOT EXISTS `usertwitter` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) NOT NULL,
  `twitter_id` varchar(120) NOT NULL,
  `username` varchar(16) NOT NULL,
  `oauth_token` varchar(120) NOT NULL,
  `oauth_secret` varchar(120) NOT NULL,
  `name` varchar(75) NOT NULL,
  `website` varchar(100) NOT NULL,
  `bio` varchar(255) NOT NULL,
  `location` varchar(100) NOT NULL,
  `avatar_url` varchar(255) NOT NULL,
  `utc_offset` int(11) NOT NULL,
  `geo_enabled` tinyint(1) NOT NULL,
  `profile_background_color` varchar(6) NOT NULL,
  `profile_text_color` varchar(6) NOT NULL,
  `profile_link_color` varchar(6) NOT NULL,
  `profile_sidebar_fill_color` varchar(6) NOT NULL,
  `profile_sidebar_border_color` varchar(6) NOT NULL,
  `profile_background_image_url` varchar(255) NOT NULL,
  `profile_background_tile` tinyint(1) NOT NULL,
  `import_enabled` tinyint(1) NOT NULL,
  `export_enabled` tinyint(1) NOT NULL,
  `last_tweet_id` varchar(30) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `user_id` (`user_id`,`twitter_id`),
  UNIQUE KEY `twitter_id` (`twitter_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;
